searchData={"items":[{"type":"module","title":"File.Only.Logger","doc":"A simple logger that writes messages to log files only (not to the console).","ref":"File.Only.Logger.html"},{"type":"macro","title":"File.Only.Logger.__using__/1","doc":"Either aliases `File.Only.Logger` (this module) and requires the alias or\nimports `File.Only.Logger`. In the latter case, you could instead simply\n`import File.Only.Logger`.","ref":"File.Only.Logger.html#__using__/1"},{"type":"macro","title":"Examples - File.Only.Logger.__using__/1","doc":"use File.Only.Logger, alias: FileLogger\n\n    use File.Only.Logger\n\n    import File.Only.Logger","ref":"File.Only.Logger.html#__using__/1-examples"},{"type":"macro","title":"File.Only.Logger.alert/3","doc":"","ref":"File.Only.Logger.html#alert/3"},{"type":"macro","title":"File.Only.Logger.app/0","doc":"Returns the application for the current process or module.\n\nReturns `:undefined` if the current process does not belong to any\napplication or the current module is not listed in any application spec.","ref":"File.Only.Logger.html#app/0"},{"type":"macro","title":"Examples - File.Only.Logger.app/0","doc":"use File.Only.Logger\n\n    error :exit, {reason} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      • App: #{app()}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#app/0-examples"},{"type":"macro","title":"File.Only.Logger.critical/3","doc":"","ref":"File.Only.Logger.html#critical/3"},{"type":"macro","title":"File.Only.Logger.debug/3","doc":"","ref":"File.Only.Logger.html#debug/3"},{"type":"macro","title":"File.Only.Logger.emergency/3","doc":"","ref":"File.Only.Logger.html#emergency/3"},{"type":"macro","title":"File.Only.Logger.error/3","doc":"Injects function `error/2` into the caller's module.\n\nThe function will execute the `do_block` and write its result to the\nconfigured error log file.","ref":"File.Only.Logger.html#error/3"},{"type":"macro","title":"Examples - File.Only.Logger.error/3","doc":"use File.Only.Logger\n\n    error :exit, {reason} do\n      \"\"\"\n      \\n'exit' caught...\n      Reason => #{inspect(reason)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#error/3-examples"},{"type":"macro","title":"File.Only.Logger.from/1","doc":"Returns a formatted heredoc to trace a message from the given `env`\n(`Macro.Env`).","ref":"File.Only.Logger.html#from/1"},{"type":"macro","title":"Examples - File.Only.Logger.from/1","doc":"use File.Only.Logger\n\n    error :exit, {reason, env} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      #{from(env)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#from/1-examples"},{"type":"macro","title":"File.Only.Logger.from/2","doc":"Returns a formatted heredoc to trace a message from the given `env`\n(`Macro.Env`) and `module`.","ref":"File.Only.Logger.html#from/2"},{"type":"macro","title":"Examples - File.Only.Logger.from/2","doc":"use File.Only.Logger\n\n    error :exit, {reason, env} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      #{from(env, __MODULE__)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#from/2-examples"},{"type":"macro","title":"File.Only.Logger.fun/1","doc":"Returns string \" . / \" e.g. \"My.Math.sqrt/1\" from the\ngiven `env` (`Macro.Env`).","ref":"File.Only.Logger.html#fun/1"},{"type":"macro","title":"Examples - File.Only.Logger.fun/1","doc":"use File.Only.Logger\n\n    error :exit, {reason, env} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      • Function: #{fun(env)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#fun/1-examples"},{"type":"macro","title":"File.Only.Logger.info/3","doc":"Injects function `info/2` into the caller's module.\n\nThe function will execute the `do_block` and write its result to the\nconfigured info log file.","ref":"File.Only.Logger.html#info/3"},{"type":"macro","title":"Examples - File.Only.Logger.info/3","doc":"use File.Only.Logger\n\n    info :game_state, {player, game} do\n      \"\"\"\n      \\nNote that #{player.name}...\n      • Has joined game #{inspect(game.name)}\n      • Game state: #{inspect(game.state)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#info/3-examples"},{"type":"macro","title":"File.Only.Logger.lib/0","doc":"Returns the current library name.","ref":"File.Only.Logger.html#lib/0"},{"type":"macro","title":"Examples - File.Only.Logger.lib/0","doc":"use File.Only.Logger\n\n    error :exit, {reason} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      • Library: #{lib()}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#lib/0-examples"},{"type":"macro","title":"File.Only.Logger.maybe_break/3","doc":"Will prefix `string` with \"\\n \" if `string` is longer than\n` ` - `offset` where ` ` and ` ` are\nrespectively the `:padding` and `:line_length` options.","ref":"File.Only.Logger.html#maybe_break/3"},{"type":"macro","title":"Options - File.Only.Logger.maybe_break/3","doc":"* `:line_length` (positive integer) - the preferred line length of messages\n    sent to the log files. Defaults to 80.\n  * `:padding` (string) - Filler inserted after the line break. Defaults to\n    \"\\s\\s\".","ref":"File.Only.Logger.html#maybe_break/3-options"},{"type":"macro","title":"Examples - File.Only.Logger.maybe_break/3","doc":"use File.Only.Logger\n\n    error :exit, {reason, env} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      • Function: #{fun(env) |> maybe_break(12)}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#maybe_break/3-examples"},{"type":"macro","title":"File.Only.Logger.mod/0","doc":"Returns the current module as a string.","ref":"File.Only.Logger.html#mod/0"},{"type":"macro","title":"Examples - File.Only.Logger.mod/0","doc":"use File.Only.Logger\n\n    error :exit, {reason} do\n      \"\"\"\n      \\n'exit' caught...\n      • Reason: #{inspect(reason)}\n      • Module: #{mod()}\\\n      \"\"\"\n    end","ref":"File.Only.Logger.html#mod/0-examples"},{"type":"macro","title":"File.Only.Logger.notice/3","doc":"","ref":"File.Only.Logger.html#notice/3"},{"type":"macro","title":"File.Only.Logger.warning/3","doc":"","ref":"File.Only.Logger.html#warning/3"},{"type":"module","title":"File.Only.Logger.App","doc":"","ref":"File.Only.Logger.App.html"},{"type":"function","title":"File.Only.Logger.App.start/2","doc":"","ref":"File.Only.Logger.App.html#start/2"},{"type":"module","title":"File.Only.Logger.Proxy","doc":"Implements logging messages to files only (not to the console).","ref":"File.Only.Logger.Proxy.html"},{"type":"function","title":"File.Only.Logger.Proxy.app/0","doc":"Returns the application for the current process or module.\n\nReturns `:undefined` if the current process does not belong to any\napplication or the current module is not listed in any application spec.","ref":"File.Only.Logger.Proxy.html#app/0"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.app/0","doc":"iex> alias File.Only.Logger.Proxy\n    iex> Proxy.app\n    :file_only_logger","ref":"File.Only.Logger.Proxy.html#app/0-examples"},{"type":"function","title":"File.Only.Logger.Proxy.from/1","doc":"Returns a formatted heredoc to trace a message from the given `env`\n(`Macro.Env`).","ref":"File.Only.Logger.Proxy.html#from/1"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.from/1","doc":"iex> alias File.Only.Logger.Proxy\n    iex> heredoc = \"\"\"\n    ...> • App: file_only_logger\n    ...> • Library: file_only_logger\n    ...> • Function:\\s\n    ...>   File.Only.Logger.ProxyTest.'doctest\\\n    ...> \"\"\"\n    iex> Proxy.from(__ENV__) =~ heredoc\n    true","ref":"File.Only.Logger.Proxy.html#from/1-examples"},{"type":"function","title":"File.Only.Logger.Proxy.from/2","doc":"Returns a formatted heredoc to trace a message from the given `env`\n(`Macro.Env`) and `module`.","ref":"File.Only.Logger.Proxy.html#from/2"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.from/2","doc":"iex> alias File.Only.Logger.Proxy\n    iex> heredoc = \"\"\"\n    ...> • App: file_only_logger\n    ...> • Library: file_only_logger\n    ...> • Module: File.Only.Logger.ProxyTest\n    ...> • Function:\\s\n    ...>   File.Only.Logger.ProxyTest.'doctest\\\n    ...> \"\"\"\n    iex> Proxy.from(__ENV__, __MODULE__) =~ heredoc\n    true","ref":"File.Only.Logger.Proxy.html#from/2-examples"},{"type":"function","title":"File.Only.Logger.Proxy.fun/1","doc":"Returns string \" . / \" e.g. \"My.Math.sqrt/1\" from the\ngiven `env` (`Macro.Env`).","ref":"File.Only.Logger.Proxy.html#fun/1"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.fun/1","doc":"iex> defmodule My.Math do\n    iex>   alias File.Only.Logger.Proxy\n    iex>   def sqrt(_number) do\n    iex>     Proxy.fun(__ENV__)\n    iex>   end\n    iex> end\n    iex> My.Math.sqrt(9)\n    \"File.Only.Logger.ProxyTest.My.Math.sqrt/1\"","ref":"File.Only.Logger.Proxy.html#fun/1-examples"},{"type":"macro","title":"File.Only.Logger.Proxy.is_pos_integer/1","doc":"Returns `true` if `value` is a positive integer, otherwise `false`.","ref":"File.Only.Logger.Proxy.html#is_pos_integer/1"},{"type":"function","title":"File.Only.Logger.Proxy.lib/0","doc":"Returns the current library name.","ref":"File.Only.Logger.Proxy.html#lib/0"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.lib/0","doc":"iex> alias File.Only.Logger.Proxy\n    iex> Proxy.lib\n    :file_only_logger","ref":"File.Only.Logger.Proxy.html#lib/0-examples"},{"type":"function","title":"File.Only.Logger.Proxy.log/2","doc":"Writes `message` to the configured log file of logging level `level`.","ref":"File.Only.Logger.Proxy.html#log/2"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.log/2","doc":"iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, \"*** String message ***\")\n    :ok\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, ~c\"*** charlist message ***\")\n    :ok\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, [~c\"*** Improper \", ~c\"List \" | \"Message ***\"])\n    :ok\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, fn -> \"*** Function message ***\" end)\n    :ok\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, %{\"first\" => {1, 2, 3}, \"last\" => [1, 2, 3]})\n    :ok\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.log(:debug, first: {?a, ?b, ?c}, last: [0, 1, 2])\n    :ok","ref":"File.Only.Logger.Proxy.html#log/2-examples"},{"type":"function","title":"File.Only.Logger.Proxy.maybe_break/3","doc":"Will prefix `string` with \"\\n \" if `string` is longer than\n` ` - `offset` where ` ` and ` ` are\nrespectively the `:padding` and `:line_length` options.","ref":"File.Only.Logger.Proxy.html#maybe_break/3"},{"type":"function","title":"Options - File.Only.Logger.Proxy.maybe_break/3","doc":"* `:line_length` (positive integer) - the preferred line length of messages\n    sent to the log files. Defaults to 80.\n  * `:padding` (string) - Filler inserted after the line break. Defaults to\n    \"\\s\\s\".","ref":"File.Only.Logger.Proxy.html#maybe_break/3-options"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.maybe_break/3","doc":"iex> alias File.Only.Logger.Proxy\n    iex> supercal = \"supercalifragilisticexpialidocious\"\n    iex> \"\"\"\n    ...> • Feeling: #{inspect(supercal) |> Proxy.maybe_break(11)}\n    ...> \"\"\"\n    \"\"\"\n    • Feeling: \"supercalifragilisticexpialidocious\"\n    \"\"\"\n\n    iex> alias File.Only.Logger.Proxy\n    iex> supercal = \"supercalifragilisticexpialidocious\"\n    iex> supercal! = \"#{supercal}ly #{supercal}!\"\n    iex> \"\"\"\n    ...> • Feeling: #{String.capitalize(supercal!) |> Proxy.maybe_break(11)}\n    ...> \"\"\"\n    \"\"\"\n    • Feeling:\\s\n      Supercalifragilisticexpialidociously supercalifragilisticexpialidocious!\n    \"\"\"\n\n    iex> import File.Only.Logger.Proxy, only: [maybe_break: 3]\n    iex> supercal = :supercalifragilisticexpialidocious\n    iex> msg = \"Today I'm feeling astonishingly #{supercal}...\"\n    iex> \"\"\"\n    ...> -- Message: #{inspect(msg) |> maybe_break(12, padding: \"\\s\\s\\s\")}\n    ...> \"\"\"\n    \"\"\"\n    -- Message:\\s\n       \"Today I'm feeling astonishingly supercalifragilisticexpialidocious...\"\n    \"\"\"","ref":"File.Only.Logger.Proxy.html#maybe_break/3-examples"},{"type":"function","title":"File.Only.Logger.Proxy.mod/1","doc":"Returns the given `module` as a string.","ref":"File.Only.Logger.Proxy.html#mod/1"},{"type":"function","title":"Examples - File.Only.Logger.Proxy.mod/1","doc":"iex> alias File.Only.Logger.Proxy\n    iex> Proxy.mod(__MODULE__)\n    \"File.Only.Logger.ProxyTest\"\n\n    iex> alias File.Only.Logger.Proxy\n    iex> Proxy.mod(Elixir.Date.Range)\n    \"Date.Range\"","ref":"File.Only.Logger.Proxy.html#mod/1-examples"},{"type":"type","title":"File.Only.Logger.Proxy.message/0","doc":"Message to be logged","ref":"File.Only.Logger.Proxy.html#t:message/0"}],"content_type":"text/markdown"}